diff -ruN vdr-1.7.38/dvbdevice.c vdr-1.7.39/dvbdevice.c
--- vdr-1.7.38/dvbdevice.c	2013-02-17 14:17:33.000000000 +0100
+++ vdr-1.7.39/dvbdevice.c	2013-02-20 10:12:12.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 2.80 2013/02/17 13:17:33 kls Exp $
+ * $Id: dvbdevice.c 2.83 2013/02/20 09:12:12 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -307,6 +307,8 @@
   bool bondedMaster;
   bool SetFrontendType(const cChannel *Channel);
   cString GetBondingParams(const cChannel *Channel = NULL) const;
+  cDvbTuner *GetBondedMaster(void);
+  bool IsBondedMaster(void) const { return !bondedTuner || bondedMaster; }
   void ClearEventQueue(void) const;
   bool GetFrontendStatus(fe_status_t &Status) const;
   void ExecuteDiseqc(const cDiseqc *Diseqc, unsigned int *Frequency);
@@ -320,7 +322,6 @@
   bool Bond(cDvbTuner *Tuner);
   void UnBond(void);
   bool BondingOk(const cChannel *Channel, bool ConsiderOccupied = false) const;
-  cDvbTuner *GetBondedMaster(void);
   const cChannel *GetTransponder(void) const { return &channel; }
   uint32_t SubsystemId(void) const { return subsystemId; }
   bool IsTunedTo(const cChannel *Channel) const;
@@ -621,15 +622,22 @@
               break;
               }
            }
+     uint16_t MinSnr = 0x0000;
      uint16_t MaxSnr = 0xFFFF; // Let's assume the default is using the entire range.
      // Use the subsystemId to identify individual devices in case they need
      // special treatment to map their Snr value into the range 0...0xFFFF.
      switch (subsystemId) {
-       case 0x13C21019: MaxSnr = 200; break; // TT-budget S2-3200 (DVB-S/DVB-S2)
+       case 0x13C21019: if (frontendType == SYS_DVBS2) { // TT-budget S2-3200 (DVB-S/DVB-S2)
+                           MinSnr = 10;
+                           MaxSnr = 70;
+                           }
+                        else
+                           MaxSnr = 200;
+                        break;
        case 0x20130245:                      // PCTV Systems PCTV 73ESE
        case 0x2013024F: MaxSnr = 255; break; // PCTV Systems nanoStick T2 290e
        }
-     int a = int(Snr) * 100 / MaxSnr;
+     int a = int(constrain(Snr, MinSnr, MaxSnr)) * 100 / (MaxSnr - MinSnr);
      int b = 100 - (Unc * 10 + (Ber / 256) * 5);
      if (b < 0)
         b = 0;
@@ -742,7 +750,7 @@
         if (const cDiseqc *diseqc = Diseqcs.Get(device->CardIndex() + 1, channel.Source(), frequency, dtp.Polarization(), &scr)) {
            frequency -= diseqc->Lof();
            if (diseqc != lastDiseqc || diseqc->IsScr()) {
-              if (GetBondedMaster() == this) {
+              if (IsBondedMaster()) {
                  ExecuteDiseqc(diseqc, &frequency);
                  if (frequency == 0)
                     return false;
@@ -768,7 +776,7 @@
            tone = SEC_TONE_ON;
            }
         int volt = (dtp.Polarization() == 'V' || dtp.Polarization() == 'R') ? SEC_VOLTAGE_13 : SEC_VOLTAGE_18;
-        if (GetBondedMaster() != this) {
+        if (!IsBondedMaster()) {
            tone = SEC_TONE_OFF;
            volt = SEC_VOLTAGE_13;
            }
diff -ruN vdr-1.7.38/dvbplayer.c vdr-1.7.39/dvbplayer.c
--- vdr-1.7.38/dvbplayer.c	2013-02-12 11:50:10.000000000 +0100
+++ vdr-1.7.39/dvbplayer.c	2013-02-25 13:15:58.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbplayer.c 2.30 2013/02/12 10:50:10 kls Exp $
+ * $Id: dvbplayer.c 2.32 2013/02/25 12:15:58 kls Exp $
  */
 
 #include "dvbplayer.h"
@@ -220,6 +220,7 @@
   cFrame *readFrame;
   cFrame *playFrame;
   cFrame *dropFrame;
+  bool resyncAfterPause;
   void TrickSpeed(int Increment);
   void Empty(void);
   bool NextFile(uint16_t FileNumber = 0, off_t FileOffset = -1);
@@ -240,6 +241,7 @@
   void SkipSeconds(int Seconds);
   void Goto(int Position, bool Still = false);
   virtual double FramesPerSecond(void) { return framesPerSecond; }
+  virtual void SetAudioTrack(eTrackType Type, const tTrackId *TrackId);
   virtual bool GetIndex(int &Current, int &Total, bool SnapToIFrame = false);
   virtual bool GetReplayMode(bool &Play, bool &Forward, int &Speed);
   };
@@ -270,6 +272,7 @@
   readFrame = NULL;
   playFrame = NULL;
   dropFrame = NULL;
+  resyncAfterPause = false;
   isyslog("replay %s", FileName);
   fileName = new cFileName(FileName, false, false, isPesRecording);
   replayFile = fileName->Open();
@@ -636,7 +639,13 @@
      DevicePlay();
      playMode = pmPlay;
      playDir = pdForward;
-    }
+     if (resyncAfterPause) {
+        int Current, Total;
+        if (GetIndex(Current, Total, true))
+           Goto(Current);
+        resyncAfterPause = false;
+        }
+     }
 }
 
 void cDvbPlayer::Forward(void)
@@ -799,6 +808,19 @@
      }
 }
 
+void cDvbPlayer::SetAudioTrack(eTrackType Type, const tTrackId *TrackId)
+{
+  if (isPesRecording)
+     return; // for some unknown reason this doesn't work with PES recordings - causes a segfault
+  if (playMode == pmPlay) {
+     int Current, Total;
+     if (GetIndex(Current, Total, true))
+        Goto(Current);
+     }
+  else if (playMode == pmPause)
+     resyncAfterPause = true;
+}
+
 bool cDvbPlayer::GetIndex(int &Current, int &Total, bool SnapToIFrame)
 {
   if (index) {
diff -ruN vdr-1.7.38/dvbspu.c vdr-1.7.39/dvbspu.c
--- vdr-1.7.38/dvbspu.c	2013-01-20 11:36:58.000000000 +0100
+++ vdr-1.7.39/dvbspu.c	2013-02-22 16:25:16.000000000 +0100
@@ -8,7 +8,7 @@
  *
  * parts of this file are derived from the OMS program.
  *
- * $Id: dvbspu.c 2.10 2013/01/20 10:36:58 kls Exp $
+ * $Id: dvbspu.c 2.11 2013/02/22 15:25:16 kls Exp $
  */
 
 #include "dvbspu.h"
@@ -399,7 +399,6 @@
     return ret;
 }
 
-
 void cDvbSpuDecoder::Draw(void)
 {
     cMutexLock MutexLock(&mutex);
diff -ruN vdr-1.7.38/dvbsubtitle.c vdr-1.7.39/dvbsubtitle.c
--- vdr-1.7.38/dvbsubtitle.c	2013-02-17 14:17:38.000000000 +0100
+++ vdr-1.7.39/dvbsubtitle.c	2013-02-22 16:25:25.000000000 +0100
@@ -7,10 +7,9 @@
  * Original author: Marco Schluessler <marco@lordzodiac.de>
  * With some input from the "subtitle plugin" by Pekka Virtanen <pekka.virtanen@sci.fi>
  *
- * $Id: dvbsubtitle.c 2.33 2013/02/17 13:17:38 kls Exp $
+ * $Id: dvbsubtitle.c 2.34 2013/02/22 15:25:25 kls Exp $
  */
 
-
 #include "dvbsubtitle.h"
 #define __STDC_FORMAT_MACROS // Required for format specifiers
 #include <inttypes.h>
diff -ruN vdr-1.7.38/menu.c vdr-1.7.39/menu.c
--- vdr-1.7.38/menu.c	2013-02-17 14:17:49.000000000 +0100
+++ vdr-1.7.39/menu.c	2013-02-19 10:33:26.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 2.79 2013/02/17 13:17:49 kls Exp $
+ * $Id: menu.c 2.80 2013/02/19 09:33:26 kls Exp $
  */
 
 #include "menu.h"
@@ -2965,6 +2965,8 @@
      for (int i = 0; i < cDevice::NumDevices(); i++) {
          if (cDevice::GetDevice(i)->ProvidesSource(cSource::stSat))
             Add(new cMenuEditIntItem(cString::sprintf(tr("Setup.LNB$Device %d connected to sat cable"), i + 1), &satCableNumbers.Array()[i], 0, NumSatDevices, tr("Setup.LNB$own")));
+         else
+            satCableNumbers.Array()[i] = 0;
          }
      }
 
diff -ruN vdr-1.7.38/recording.c vdr-1.7.39/recording.c
--- vdr-1.7.38/recording.c	2013-02-17 14:17:55.000000000 +0100
+++ vdr-1.7.39/recording.c	2013-03-03 11:54:05.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.88 2013/02/17 13:17:55 kls Exp $
+ * $Id: recording.c 2.89 2013/03/03 10:54:05 kls Exp $
  */
 
 #include "recording.h"
@@ -910,7 +910,7 @@
   delete info;
 }
 
-char *cRecording::StripEpisodeName(char *s)
+char *cRecording::StripEpisodeName(char *s, bool Strip)
 {
   char *t = s, *s1 = NULL, *s2 = NULL;
   while (*t) {
@@ -931,8 +931,10 @@
      // by '0' in SortName() (see below), which will result in the desired
      // sequence:
      *s1 = '1';
-     s1++;
-     memmove(s1, s2, t - s2 + 1);
+     if (Strip) {
+        s1++;
+        memmove(s1, s2, t - s2 + 1);
+        }
      }
   return s;
 }
@@ -941,8 +943,7 @@
 {
   char **sb = (RecordingsSortMode == rsmName) ? &sortBufferName : &sortBufferTime;
   if (!*sb) {
-     char *s = (RecordingsSortMode == rsmName) ? strdup(FileName() + strlen(VideoDirectory))
-                                              : StripEpisodeName(strdup(FileName() + strlen(VideoDirectory)));
+     char *s = StripEpisodeName(strdup(FileName() + strlen(VideoDirectory)), RecordingsSortMode != rsmName);
      strreplace(s, '/', '0'); // some locales ignore '/' when sorting
      int l = strxfrm(NULL, s, 0) + 1;
      *sb = MALLOC(char, l);
diff -ruN vdr-1.7.38/recording.h vdr-1.7.39/recording.h
--- vdr-1.7.38/recording.h	2013-02-14 16:13:14.000000000 +0100
+++ vdr-1.7.39/recording.h	2013-03-03 11:48:39.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 2.44 2013/02/14 15:13:14 kls Exp $
+ * $Id: recording.h 2.45 2013/03/03 10:48:39 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -97,7 +97,7 @@
   cRecordingInfo *info;
   cRecording(const cRecording&); // can't copy cRecording
   cRecording &operator=(const cRecording &); // can't assign cRecording
-  static char *StripEpisodeName(char *s);
+  static char *StripEpisodeName(char *s, bool Strip);
   char *SortName(void) const;
   int GetResume(void) const;
   time_t start;
diff -ruN vdr-1.7.38/remux.c vdr-1.7.39/remux.c
--- vdr-1.7.38/remux.c	2013-02-17 14:17:58.000000000 +0100
+++ vdr-1.7.39/remux.c	2013-03-03 11:37:58.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.c 2.74 2013/02/17 13:17:58 kls Exp $
+ * $Id: remux.c 2.75 2013/03/03 10:37:58 kls Exp $
  */
 
 #include "remux.h"
@@ -718,7 +718,7 @@
                          if (updatePrimaryDevice)
                             cDevice::PrimaryDevice()->SetAvailableTrack(ttAudio, NumApids, apids[NumApids], alangs[NumApids]);
                          NumApids++;
-                         apids[NumApids]= 0;
+                         apids[NumApids] = 0;
                          }
                       }
                       break;
@@ -765,7 +765,7 @@
                                     if (updatePrimaryDevice)
                                        cDevice::PrimaryDevice()->SetAvailableTrack(ttSubtitle, NumSpids, spids[NumSpids], slangs[NumSpids]);
                                     NumSpids++;
-                                    spids[NumSpids]= 0;
+                                    spids[NumSpids] = 0;
                                     }
                                  break;
                             case SI::ISO639LanguageDescriptorTag: {
@@ -786,7 +786,7 @@
                             if (updatePrimaryDevice && Setup.UseDolbyDigital)
                                cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, NumDpids, dpid, lang);
                             NumDpids++;
-                            dpids[NumDpids]= 0;
+                            dpids[NumDpids] = 0;
                             }
                          }
                       }
@@ -815,7 +815,7 @@
                          if (updatePrimaryDevice && Setup.UseDolbyDigital)
                             cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, NumDpids, stream.getPid(), lang);
                          NumDpids++;
-                         dpids[NumDpids]= 0;
+                         dpids[NumDpids] = 0;
                          }
                       }
                       break;
diff -ruN vdr-1.7.38/shutdown.c vdr-1.7.39/shutdown.c
--- vdr-1.7.38/shutdown.c	2008-02-24 11:29:00.000000000 +0100
+++ vdr-1.7.39/shutdown.c	2013-02-18 11:33:26.000000000 +0100
@@ -6,7 +6,7 @@
  *
  * Original version written by Udo Richter <udo_richter@gmx.de>.
  *
- * $Id: shutdown.c 2.0 2008/02/24 10:29:00 kls Exp $
+ * $Id: shutdown.c 2.1 2013/02/18 10:33:26 kls Exp $
  */
 
 #include "shutdown.h"
@@ -117,7 +117,7 @@
   else {
      // Set inactive from now on
      dsyslog("scheduled wakeup time in %ld minutes, assuming automatic start of VDR", Delta / 60);
-     SetUserInactive();
+     SetUserInactiveTimeout(-3, true);
      }
 }
 
@@ -147,9 +147,14 @@
      activeTimeout = 0;
      return;
      }
-  if (Seconds < 0)
-     Seconds = Setup.MinUserInactivity * 60;
-  activeTimeout = time(NULL) + Seconds;
+  if (Seconds >= 0)
+     activeTimeout = time(NULL) + Seconds;
+  else if (Seconds == -1)
+     activeTimeout = time(NULL) + Setup.MinUserInactivity * 60;
+  else if (Seconds == -2)
+     activeTimeout = 0;
+  else if (Seconds == -3)
+     activeTimeout = 1;
 }
 
 bool cShutdownHandler::ConfirmShutdown(bool Interactive)
diff -ruN vdr-1.7.38/shutdown.h vdr-1.7.39/shutdown.h
--- vdr-1.7.38/shutdown.h	2007-02-24 18:23:59.000000000 +0100
+++ vdr-1.7.39/shutdown.h	2013-02-18 11:35:27.000000000 +0100
@@ -6,7 +6,7 @@
  *
  * Original version written by Udo Richter <udo_richter@gmx.de>.
  *
- * $Id: shutdown.h 2.0 2007/02/24 17:23:59 kls Exp $
+ * $Id: shutdown.h 2.1 2013/02/18 10:35:27 kls Exp $
  */
 
 #ifndef __SHUTDOWN_H
@@ -38,7 +38,7 @@
 class cShutdownHandler {
 private:
   time_t activeTimeout;
-       ///< Time when VDR will become non-interactive. 0 means never.
+       ///< Time when VDR will become non-interactive. 0 means never, 1 means unknown time ago.
   time_t retry;
        ///< Time for retrying the shutdown.
   char *shutdownCommand;
@@ -73,15 +73,18 @@
        ///< Check whether VDR is in interactive mode or non-interactive mode (waiting for shutdown).
        ///< AtTime checks whether VDR will probably be inactive at that time.
   time_t GetUserInactiveTime(void) { return activeTimeout; }
-       ///< Time when user will become non-inactive, or 0 if never.
+       ///< Time when user will become non-inactive, or 0 if never, 1 if a long time ago
   void SetUserInactiveTimeout(int Seconds = -1, bool Force = false);
-       ///< Set the time when VDR will switch into non-interactive mode or power down.
-       ///< -1 means Setup.MinUserInactivity in the future.
-       ///< Otherwise, seconds in the future.
-       ///< If MinUserInactivity = 0 and Force = false, Seconds is ignored and VDR will
-       ///< stay interactive forever.
+       ///< Set the time in the future when VDR will switch into non-interactive mode or power down.
+       ///< Seconds >= 0 means that many seconds in the future.
+       ///< Seconds = -1 means Setup.MinUserInactivity in the future.
+       ///< Seconds = -2 means never.
+       ///< Seconds = -3 means a long, unknown time ago.
+       ///< Setup.MinUserInactivity = 0 will overrule this, unless Force = true is given.
+       ///< If Setup.MinUserInactivity = 0 and Force = false, Seconds is ignored and VDR will
+       ///< stay interactive forever (like Seconds = -2).
   void SetUserInactive(void) { SetUserInactiveTimeout(0, true); }
-       ///< Set VDR manually into non-interactive mode.
+       ///< Set VDR manually into non-interactive mode from now on.
   bool Retry(time_t AtTime = 0) { return retry <= (AtTime ? AtTime : time(NULL)); }
        ///< Check whether its time to re-try the shutdown.
        ///< AtTime checks whether VDR will probably be inactive at that time.
diff -ruN vdr-1.7.38/skinclassic.c vdr-1.7.39/skinclassic.c
--- vdr-1.7.38/skinclassic.c	2012-09-09 13:39:06.000000000 +0200
+++ vdr-1.7.39/skinclassic.c	2013-02-22 16:25:31.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinclassic.c 2.8 2012/09/09 11:39:06 kls Exp $
+ * $Id: skinclassic.c 2.9 2013/02/22 15:25:31 kls Exp $
  */
 
 #include "skinclassic.h"
@@ -773,7 +773,6 @@
   return new cSkinClassicDisplayVolume;
 }
 
-
 cSkinDisplayTracks *cSkinClassic::DisplayTracks(const char *Title, int NumTracks, const char * const *Tracks)
 {
   return new cSkinClassicDisplayTracks(Title, NumTracks, Tracks);
diff -ruN vdr-1.7.38/thread.c vdr-1.7.39/thread.c
--- vdr-1.7.38/thread.c	2012-10-04 14:20:43.000000000 +0200
+++ vdr-1.7.39/thread.c	2013-02-22 15:52:49.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.c 2.6 2012/10/04 12:20:43 kls Exp $
+ * $Id: thread.c 2.7 2013/02/22 14:52:49 kls Exp $
  */
 
 #include "thread.h"
@@ -598,4 +598,3 @@
      _exit(0);
      }
 }
-
diff -ruN vdr-1.7.38/transfer.c vdr-1.7.39/transfer.c
--- vdr-1.7.38/transfer.c	2013-01-20 14:40:30.000000000 +0100
+++ vdr-1.7.39/transfer.c	2013-03-01 10:50:15.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.c 2.7 2013/01/20 13:40:30 kls Exp $
+ * $Id: transfer.c 2.8 2013/03/01 09:50:15 kls Exp $
  */
 
 #include "transfer.h"
@@ -15,7 +15,6 @@
 :cReceiver(Channel, TRANSFERPRIORITY)
 {
   patPmtGenerator.SetChannel(Channel);
-  retriesExceeded = false;
 }
 
 cTransfer::~cTransfer()
@@ -38,7 +37,6 @@
 
 #define MAXRETRIES     5 // max. number of retries for a single TS packet
 #define RETRYWAIT      5 // time (in ms) between two retries
-#define RETRYPAUSE 10000 // time (in ms) for which to pause retrying once a packet has not been accepted
 
 void cTransfer::Receive(uchar *Data, int Length)
 {
@@ -48,17 +46,11 @@
      // now and then there may be conditions where the packet just can't be
      // handled when offered the first time, so that's why we try several times:
      for (int i = 0; i < MAXRETRIES; i++) {
-         if (PlayTs(Data, Length) > 0) {
-            if (retriesExceeded && timer.TimedOut())
-               retriesExceeded = false;
-            return;
-            }
-         if (retriesExceeded) // no retries once a packet has not been accepted
+         if (PlayTs(Data, Length) > 0)
             return;
          cCondWait::SleepMs(RETRYWAIT);
          }
-     retriesExceeded = true;
-     timer.Set(RETRYPAUSE); // wait a while before retrying
+     DeviceClear();
      esyslog("ERROR: TS packet not accepted in Transfer Mode");
      }
 }
diff -ruN vdr-1.7.38/transfer.h vdr-1.7.39/transfer.h
--- vdr-1.7.38/transfer.h	2013-01-20 14:12:38.000000000 +0100
+++ vdr-1.7.39/transfer.h	2013-03-01 10:49:46.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.h 2.3 2013/01/20 13:12:38 kls Exp $
+ * $Id: transfer.h 2.4 2013/03/01 09:49:46 kls Exp $
  */
 
 #ifndef __TRANSFER_H
@@ -13,13 +13,10 @@
 #include "player.h"
 #include "receiver.h"
 #include "remux.h"
-#include "tools.h"
 
 class cTransfer : public cReceiver, public cPlayer {
 private:
   cPatPmtGenerator patPmtGenerator;
-  bool retriesExceeded;
-  cTimeMs timer;
 protected:
   virtual void Activate(bool On);
   virtual void Receive(uchar *Data, int Length);
diff -ruN vdr-1.7.38/vdr.c vdr-1.7.39/vdr.c
--- vdr-1.7.38/vdr.c	2013-02-14 11:49:06.000000000 +0100
+++ vdr-1.7.39/vdr.c	2013-03-03 11:25:11.000000000 +0100
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.tvdr.de
  *
- * $Id: vdr.c 2.49 2013/02/14 10:49:06 kls Exp $
+ * $Id: vdr.c 2.50 2013/03/03 10:25:11 kls Exp $
  */
 
 #include <getopt.h>
@@ -1301,9 +1301,9 @@
               EITScanner.Process();
            if (!cCutter::Active() && cCutter::Ended()) {
               if (cCutter::Error())
-                 Skins.QueueMessage(mtError, tr("Editing process failed!"));
+                 Skins.Message(mtError, tr("Editing process failed!"));
               else
-                 Skins.QueueMessage(mtInfo, tr("Editing process finished"));
+                 Skins.Message(mtInfo, tr("Editing process finished"));
               }
            }
 
